freeslot("S_PLAY_SLAM","S_PLAY_SPINJUMP","S_FLUDDWATER","MT_FLUDDWATER","SPR2_SLAM",
"sfx_ptslam","sfx_ptstsl","sfx_swsjmp","sfx_kmspin","sfx_kmwkik","sfx_kwskid","sfx_kswtch","sfx_m64unh","sfx_m64doh","sfx_m64oof","sfx_kmbip0","sfx_kmbip1")

mobjinfo[MT_FLUDDWATER] = {
spawnstate = S_WARIOLAND10COIN,
spawnhealth = 1000,
deathstate = S_WARIOLAND10COIN,
radius = mobjinfo[MT_RING].radius,
height = mobjinfo[MT_RING].height,
dispoffset = 4,
flags = MF_SCENERY,
}

states[S_FLUDDWATER] = {
	sprite = SPR_WLC1,
	frame = FF_ANIMATE|A,
	tics = -1,
	var1 = 3,
	var2 = 2,
	nextstate = S_FLUDDWATER,
}

states[S_PLAY_SLAM] = {
	sprite = SPR_PLAY,
	frame = SPR2_SLAM,
	tics = -1,
	nextstate = S_PLAY_SLAM,
}
spr2defaults[SPR2_SLAM] = SPR2_ROLL
states[S_PLAY_SPINJUMP] = {
	sprite = SPR_PLAY,
	frame = SPR2_STND,
	tics = -1,
	nextstate = S_PLAY_SPINJUMP,
}

addHook("PlayerSpawn", function(player)
		player.slamstate = 0
		player.spinangle = 0
		player.instad = false
		player.spinjumping = false
		player.realmo.walljumps = 0
end)

local spinangle = 0

sfxinfo[sfx_ptstsl].caption = "Groundslam Starting"
sfxinfo[sfx_ptslam].caption = 'Groundslam'
sfxinfo[sfx_swsjmp].caption = 'Spinjump'
sfxinfo[sfx_kswtch].caption = 'Mode Switch'
sfxinfo[sfx_kmspin].caption = 'Boosted Spinjump'
sfxinfo[sfx_kmwkik].caption = 'Wallkick'
sfxinfo[sfx_m64unh].caption = "Unh!"
sfxinfo[sfx_m64doh].caption = "D'oh!"
sfxinfo[sfx_m64oof].caption = "Oof!"
sfxinfo[sfx_kmbip0].caption = "Eh..!"
sfxinfo[sfx_kmbip1].caption = "Hup!"

addHook("AbilitySpecial", function(player)
	if not (player.valid and player.realmo and player.realmo.valid) then return end
	if player.kombimode == 1 and not (player.pflags & PF_THOKKED) then return end
	if player.realmo.collidewall and srb2p then return false end
		if player.realmo.skin == "shyne"
		
		end
		if (player.realmo.skin != "kombi") then return end
		
		if not (player.pflags & PF_THOKKED)
			player.pflags = $|PF_THOKKED
			if not srb2p
				player.powers[pw_strong] = STR_STOMP|STR_ANIM
			end
			player.spinjumping = true
			player.realmo.state = S_PLAY_SPINJUMP
			if not (player.powers[pw_shield] & SH_ARMAGEDDON == 2)
				P_SetObjectMomZ(player.realmo, 12*FRACUNIT, (player.realmo.momz*P_MobjFlip(player.mo) > 0))
				S_StartSound(player.realmo,sfx_swsjmp)
			else
				P_SetObjectMomZ(player.realmo, 20*FRACUNIT, (player.realmo.momz*P_MobjFlip(player.mo) > 0))
				S_StartSound(player.realmo,sfx_kmspin)
			end
		elseif player.realmo.state == S_PLAY_SPINJUMP
			player.nospindash = true
			player.slamstate = 1
			player.realmo.momx = $/2
			player.realmo.momy = $/2
			P_SetObjectMomZ(player.realmo, 5*FRACUNIT, false)
			player.realmo.state = S_PLAY_ROLL
			player.spinjumping = false
			if not player.powers[pw_super]
				player.charflags = $&~SF_SUPER
			end
			S_StartSound(player.realmo,sfx_ptstsl)
		end
	return true
end)

addHook("MobjThinker", function(mobj)
	P_InstaThrust(mobj, mobj.angle, 36*FRACUNIT)
end, MT_FLUDDWATER)

addHook("MobjCollide", function(tm, mo) -- I. HATE. DOORS!!
	if mo.player and mo.player.punching or abs(mo.momx) + abs(mo.momy) >= 35*FRACUNIT
		if not mo.valid or not tm.valid then return end
		if not (mo.flags & MF_NOCLIPTHING)
			P_KillMobj(tm, mo, MT_SALOONDOOR)
			mo.storemomx = mo.momx
			mo.storemomy = mo.momy
			mo.storemomz = mo.momz
			mo.pause = 8
			S_StartSound(mo, sfx_wbreak)
		end
	end
end, MT_SALOONDOORCENTER)

addHook("SpinSpecial", function(player)
	if player.realmo.skin == "shyne" and player.smswater > 0
		player.kombismswater = P_SpawnMobjFromMobj(player.realmo, 0, 0, player.mo.height, MT_FLUDDWATER)
		player.kombismswater.fuse = 35
		player.kombismswater.angle = player.realmo.angle
		player.smswater = $ - (1*FRACUNIT/6)
		return true
	end
end)

addHook("PlayerThink", function(player)
	if player.realmo.skin == "shyne" and (player.realmo.eflags & MFE_UNDERWATER) and player.smswater < 100*FRACUNIT
		player.smswater = $+FRACUNIT
	end
	if player.realmo.collidewall
		if not player.powers[pw_super]
			player.charflags = $&~SF_SUPER
		end
		player.charflags = $|SF_NOSHIELDABILITY
	end
	if player.smswater > 100*FRACUNIT player.smswater = 100*FRACUNIT end
	player.slamstate = $ or 0
	if player.slamstate
		if player.mo.skin == "trez" and not player.grounded
			player.mo.state = S_PLAY_SLAM
			player.powers[pw_strong] = STR_BOUNCE
		end
		if player.realmo.collidewall and not player.powers[pw_super]
			player.charflags = $&~SF_SUPER
		end
		player.charflags = $|SF_NOSHIELDABILITY
	else
		if (player.charflags & SF_NOSHIELDABILITY) and not (skins[player.mo.skin].flags & SF_NOSHIELDABILITY)
			player.charflags = $&~SF_NOSHIELDABILITY
		end
		if not (player.charflags & SF_SUPER) and (skins[player.mo.skin].flags & SF_SUPER)
			player.charflags = $|SF_SUPER
		end
		if player.mo and player.mo.skin == "trez"
			player.powers[pw_strong] = 0
			player.slamstate = 0
		end
	end
	if not player.realmo.pushing
		player.realmo.pushing = 0
	else
		player.realmo.pushing = $ - 1
	end
	if not player.realmo.pause
		player.realmo.pause = -35
	end
	if not player.realmo.state == S_PLAY_FALL
		player.realmo.pushing = 0
	end
	if player.realmo.pause
		player.realmo.pause = $-1
		player.momx = 0
		player.momy = 0
		player.momz = 0
	elseif player.realmo.pause == 0
		player.realmo.pause = -35
		player.momx = player.storemomx
		player.momy = player.storemomy
		player.momz = player.storemomz
	end
	if not (player.valid and player.realmo and player.realmo.valid) return end
	if (player.realmo.skin != "kombi") return end
	
	if player.kombiboost == nil player.kombiboost = FRACUNIT end
	
	if player.realmo.state == S_PLAY_SPINJUMP then
		player.spinangle = ($ or 0) + FixedAngle(60*FRACUNIT)
		player.drawangle = player.spinangle
	end
	
	if player.instad == nil
		player.instad = false
	end
	
	if player.slamstate > 0
		if (player.cmd.buttons & BT_SPIN) and not srb2p then P_SetObjectMomZ(player.realmo, -1*FRACUNIT, true) end
	end
	
	if player.slamstate == 1 and player.realmo.momz <= 0
		player.slamstate = 2
		player.realmo.state = S_PLAY_SLAM
		if not srb2p
			player.powers[pw_strong] = STR_BOUNCE
		end
	end
	
	if player.slamstate == 2
		if player.grounded
			player.slamstate = 0
			if (player.cmd.buttons & BT_JUMP)
				if player.kombimode == 0
					player.nospindash = false
					player.realmo.state = S_PLAY_ROLL
					player.pflags = $|PF_JUMPED&~PF_THOKKED
					P_SetObjectMomZ(player.realmo, 15*FRACUNIT, false)
				else
					player.nospindash = false
					player.realmo.state = S_PLAY_ROLL
					player.pflags = $|PF_SPINNING
					P_Thrust(player.realmo, player.realmo.angle, 12*FRACUNIT)
					S_StartSound(player.realmo,sfx_zoom)
				end
			end
			S_StartSound(player.realmo,sfx_ptslam)
		end
	end
	if P_IsObjectOnGround(player.realmo)
		player.spinjumping = false
		player.instad = false
		player.grounded = true
	else
		player.grounded = false
	end
	if not player.switchwait
		player.switchwait = 0
	end
	if player.switchwait
		player.switchwait = $ - 1
	end
	if player.kombimode
		player.charability = CA_HOMINGTHOK
	else
		player.charability = CA_DOUBLEJUMP
	end
	if (player.cmd.buttons & BT_CUSTOM3) and not player.switchwait
		player.kombimode = ($+1)%2
		S_StartSound(player.realmo, sfx_kswtch)
		player.switchwait = 8
	end
	if (player.cmd.buttons & BT_CUSTOM1) and player.kombiboost > 0
		player.kombiboost = $ - (FRACUNIT/192)
		P_InstaThrust(player.mo,player.drawangle,60*FRACUNIT)
		if not player.kombiboosting
			S_StartSound(player.realmo, sfx_cdfm01)
			S_StartSound(player.realmo, sfx_lspdst)
			player.kombiboosting = true
		elseif not S_SoundPlaying(player.mo, sfx_lspdst) and not S_SoundPlaying(player.mo, sfx_lspdlo)
			S_StartSound(player.realmo, sfx_lspdlo)
		end
	else
		if player.kombiboost > (FRACUNIT/2)+FRACUNIT
			player.kombiboost = $ - (FRACUNIT/256)
		elseif player.kombiboost > FRACUNIT
			player.kombiboost = $ - (FRACUNIT/512)
			if player.kombiboost < FRACUNIT player.kombiboost = FRACUNIT end
		end
		if player.kombiboost < 0 player.kombiboost = 0 end
		if player.kombiboosting
			S_StopSoundByID(player.realmo, sfx_lspdst)
			S_StopSoundByID(player.realmo, sfx_lspdlo)
			player.mo.momx = $/2
			player.mo.momy = $/2
			player.kombiboosting = false
		end
	end
end)

addHook("MobjDamage", function(mo,mobj,src,dmg,dmgtype)
	if not (mo and mo.valid) then return end
	if not ((mo.flags & MF_SHOOTABLE) or (mo.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR))) then return end
	
	if not (mobj and mobj.valid) then return end
	if not (mobj.player and mobj.player.valid) then return end
	if mobj.player.pflags & PF_THOKKED >= 1
		mobj.player.pflags = $&~PF_THOKKED
	end
end)

addHook("JumpSpinSpecial", function(player)
	if player.kombimode == 1 and player.realmo.skin == "kombi"
		if not (player.valid and player.realmo and player.realmo.valid) then return true end
			if player.realmo.skin == "kombi" and not player.instad
				
				player.instad = true
			end
		return true
	end
end)

rawset(_G, "cv_kombiwallkicktype", CV_RegisterVar({
	name = "k_instantwallkick",
	defaultvalue = "Off",
	flags = CV_SAVE|CV_SHOWMODIF,
	PossibleValue = {On = 1, Off = 0},
}))

rawset(_G, "cv_kombibonkers", CV_RegisterVar({
	name = "k_bonking",
	defaultvalue = "Off",
	flags = CV_SAVE|CV_SHOWMODIF,
	PossibleValue = {On = 1, Off = 0},
}))

/// Ability: Wall-Jump
// allows you to cling to walls, and leap off of them

// CUSTOMIZE SECTION START
local skin = "kombi" // your character here
local thebutton = BT_SPIN // the button needed to do the wall jump
if srb2p
	thebutton = BT_JUMP // the button needed to do the wall jump
end
local wallkickheight = 20 // the upwards thrust of the walljump
local wallkickthrust = 15 // the thrust of the wall jump
local sound = sfx_kmwkik // sound of the wall jump
// CUSTOMIZE SECTION END PROCCED BELOW IF YOU KNOW WHAT YOUR DOING

addHook("PlayerThink", function(player)
	if CV_FindVar("k_instantwallkick").string == "Off"
		if player.realmo.walljump == nil
			player.realmo.walljump = false
		end
		if player.realmo.collidewall == nil
			player.realmo.collidewall = 0
		end
		if player.realmo.collidewall > 0
			player.realmo.collidewall = $ - 1
		end
		if P_IsObjectOnGround(player.realmo)
			player.realmo.walljumps = 0
		end
		if player.kombimode == 0 and player.realmo and player.realmo.skin == skin
		and (player.cmd.buttons & thebutton)
		and not P_IsObjectOnGround(player.realmo)
		and player.realmo.collidewall
		and not player.realmo.walljump
			player.realmo.walljump = true
			player.realmo.state = S_PLAY_CLING
			player.pflags = $|PF_FULLSTASIS
			P_SpawnSkidDust(player, player.realmo.radius, false)
			S_StartSound(player.realmo, sfx_kwskid)
			P_SetObjectMomZ(player.realmo, 0)
		end
		if player.realmo.walljump == true
		and player.realmo.collidewall
			player.realmo.state = S_PLAY_CLING
			player.pflags = $|PF_FULLSTASIS
			player.pflags = $ & ~PF_GLIDING
			P_SpawnSkidDust(player, player.realmo.radius, false)
			S_StartSound(player.realmo, sfx_kwskid)
			P_SetObjectMomZ(player.realmo, -2*FRACUNIT)
		end
		if player.realmo and player.realmo.skin == skin
		and not (player.cmd.buttons & thebutton)
		and not P_IsObjectOnGround(player.realmo)
		and player.realmo.walljump == true
		and player.realmo.collidewall
			player.realmo.walljump = false
			player.realmo.collidewall = 0
			player.realmo.angle = $ + ANGLE_180
			player.drawangle = player.realmo.angle
			P_InstaThrust(player.realmo, player.realmo.angle, wallkickthrust*FRACUNIT)
			if player.realmo.walljumps > 4
				P_SetObjectMomZ(player.realmo, FixedDiv(wallkickheight*FRACUNIT, max((player.realmo.walljumps - 4)*FRACUNIT, FRACUNIT)))
			else		
				P_SetObjectMomZ(player.realmo, wallkickheight*FRACUNIT)
			end
			if player.realmo.walljumps == 0 and (player.pflags & PF_THOKKED)
				player.pflags = $&~PF_THOKKED
			end
			S_StartSound(player.realmo, sound)
			player.realmo.walljumps = $ + 1
			player.realmo.state = S_PLAY_ROLL
			player.pflags = $|PF_JUMPED
		end
		if player.realmo.walljump == true
		and player.realmo.collidewall == 0
		and not (player.cmd.buttons & thebutton)
		and not P_IsObjectOnGround(player.realmo)
			player.realmo.walljump = false
			player.realmo.state = S_PLAY_FALL
			player.pflags = $1 & ~PF_FULLSTASIS
		end
	else
		if player.realmo.collidewall == nil
			player.realmo.collidewall = 0
		end
		if player.realmo.collidewall > 0
			player.realmo.collidewall = $ - 1
		end
		if P_IsObjectOnGround(player.realmo)
			player.realmo.walljumps = 0
		end
		if player.realmo and player.realmo.skin == skin
		and (player.cmd.buttons & thebutton)
		and not P_IsObjectOnGround(player.realmo)
		and player.realmo.collidewall
			player.realmo.walljump = false
			player.realmo.collidewall = 0
			player.realmo.angle = $ + ANGLE_180
			player.drawangle = player.realmo.angle
			P_InstaThrust(player.realmo, player.realmo.angle, wallkickthrust*FRACUNIT)
			if player.realmo.walljumps > 4
				P_SetObjectMomZ(player.realmo, FixedDiv(wallkickheight*FRACUNIT, (player.realmo.walljumps - 4)*FRACUNIT))
			else		
				P_SetObjectMomZ(player.realmo, wallkickheight*FRACUNIT)
			end
			if player.realmo.walljumps == 0 and (player.pflags & PF_THOKKED)
				player.pflags = $&~PF_THOKKED
			end
			S_StartSound(player.realmo, sound)
			player.realmo.walljumps = $ + 1
			player.realmo.state = S_PLAY_ROLL
			player.pflags = $|PF_JUMPED
		end
	end
end)

addHook("MobjMoveBlocked", function(mo,mobj,line)
	if mo.skin == skin and not P_IsObjectOnGround(mo)
	and not (mobj and mobj.valid and mobj.flags & (MF_MONITOR|MF_ENEMY|MF_BOSS))
		if PTR_GlideClimbTraverse(mo,line)
		and mo.player and mo.player.valid
			local real,ang = PTR_GlideClimbTraverse(mo,line)
			if line and line.valid
				if (P_IsClimbingValid(mo.player,ang) or (mobj and mobj.valid))
					if mobj and mobj.valid then end
					mo.collidewall = 10
				end
			end
		elseif mobj and mobj.valid
			mo.collidewall = 10
		end
	end
end, MT_PLAYER)

addHook("MobjMoveBlocked", function(mo,mobj,line)
	if mo.skin == skin and not P_IsObjectOnGround(mo) and PTR_GlideClimbTraverse(mo,line)
		if abs(mo.momx) + abs(mo.momy) >= 20*FRACUNIT+FRACUNIT/4 and cv_kombibonkers.string == "On"
			if abs(mo.momx) + abs(mo.momy) >= 32*FRACUNIT
				S_StartSound(mo, sfx_m64doh)
				mo.state = S_PLAY_PAIN
			else
				S_StartSound(mo, sfx_m64unh)
				mo.state = S_PLAY_FALL
			end
			P_InstaThrust(mo, mo.angle, -4*FRACUNIT)
		end
	elseif mo.skin == skin and PTR_GlideClimbTraverse(mo,line)
		if mo.pushing >= 10
			if mo.pushing == 10
				S_StartSound(mo, P_RandomRange(sfx_kmbip0,sfx_kmbip1))
			end
			mo.state = S_PLAY_FALL
		end
		mo.pushing = $ + 2
	end
end, MT_PLAYER)